<%
' TabControl v 3.0.4
' Provides XP style tabs to control Dynamic, Inline Frames or PostBack page content naivgation.
' Written by Hunter Beanland

Const TabTypeFrames = 1
Const TabTypePostBack = 2
Const TabTypeDynamic = 3

Class TabControl
    Private TabListText()
    Private TabListIcon()
    Private TabListAction()
    Private RowList()
	Public TabCount		'READ ONLY Integer. 0*
	Public Height		'String: % or px. "80%"*
	Public Width		'String: % or px. "100%"*
	Public TabWidth		'String: px. ""*
	Public TabHeight	'String: px. "21"*
	Public BGColor		'String: named or # hex. "#FFFFFF"*
	Public TabType		'TabTypes: 1 = Frames*, 2 = Postback, 3 = Dynamic
	Public TabSelected	'Integer: 1* ...
	Public TabHome		'Boolean: True/False*
    Public ControlImagePath		'String: path. 
    Public ControlScriptPath	'String: path.
    Public ApplyContentStyle 'Boolean: True*/False
	Public OnClick		'String: javascript command. ""*
    
	Private Sub Class_Initialize()
		ControlImagePath = left(request.ServerVariables("URL"),instrrev(request.ServerVariables("URL"),"/"))
		ControlScriptPath = ControlImagePath
		BGColor = "#FFFFFF"
		Height = "80%"
		Width = "100%"
		TabSelected = 1
		TabType = 1
		Redim TabListText(0)
		redim TabListIcon(0)
		redim TabListAction(0)
        ReDim RowList(0)
		TabCount = 0
		TabWidth = ""
		TabHeight = "21"
		TabHome = False
		ApplyContentStyle = True
		OnClick = ""
	End Sub
	
	Public Sub AddTab (TabText, TabImage, TabIDAction)
        'Add the tab data to our array
        TabCount = TabCount + 1
        ReDim Preserve TabListText(TabCount)
        ReDim Preserve TabListIcon(TabCount)
        ReDim Preserve TabListAction(TabCount)
        TabListText(TabCount) = TabText
        TabListIcon(TabCount) = TabImage
        if TabIDAction = "" then TabIDAction = "tab" & TabCount
        TabListAction(TabCount) = TabIDAction
	End Sub
	
	Public Sub NewRow()
        'Add new row marker to next tab
        ReDim Preserve RowList(UBound(RowList) + 1)
        RowList(UBound(RowList)) = TabCount + 1
    End Sub
    
    Public Sub SelectTabName(TabText)
		'Select a tab via it's name
		Dim intLoop
		For intLoop = 1 to ubound(TabListText,1)
			If TabText = TabListText(intLoop) Then
				TabSelected = intLoop
				Exit For
			End If
		Next
	End Sub
	
	Public Sub Draw()
		'Draw the tab control
		'This code is ported back from ASP.NET, so i am trying to keep the code similar to help me upkeep it
		'"PreRender" first
        If TabCount = 0 Then Exit Sub
        If TabSelected > TabCount Then TabSelected = TabCount
        If TabSelected < 1 Then TabSelected = 1
        Dim strOut
        Dim intCurrTab
        'Init js variables
        strOut = strOut & "<script Language='JavaScript'>TabImagePath=""" & ControlImagePath & """; " & _
            "intTabType=" & TabType & "; " & _
            "strHeight=""" & Height & """; " & _
            "strWidth=""" & Width & """; " & _
            "strOnClick=""" & replace(OnClick,"""","'") & """; " & _
            "strPrevTab=""" & TabSelected & """; " & _
            "strPrevContentID="""
        If TabType = TabTypeFrames Then
            strOut = strOut & "TabContent" & TabSelected & """;" & vbLf
            If TabHome Then
                strOut = strOut & "var tabList = new Array("
                For intCurrTab = 1 To UBound(TabListText)
                    If intCurrTab > 1 Then strOut = strOut & ","
                    strOut = strOut & "'" & TabListAction(intCurrTab) & "'"
                Next
                strOut = strOut & ");"
            End If
        Else
            strOut = strOut & TabListAction(TabSelected) & """;"
        End If
        strOut = strOut & "</script>" & vbLf
        Response.Write(strOut)

        'Style and JS libraries
        Response.Write("<style>.Tab { font-weight: normal; font-size: 8pt; cursor: default; color: #0000ff; font-style: normal; font-family: ""MS Sans Serif"", Arial, sans-serif; text-align : center; }" & vbLf & _
            ".TabContent { border-left:solid 1px #919B9C; border-bottom:solid 1px #919B9C; border-right:solid 1px #919B9C; }</style>" & vbLf)
        Response.Write("<script Language='JavaScript' src='" & ControlScriptPath & "tabcontrol.js'></script>")

        If TabType = TabTypeDynamic Then
            'Start script (Dynamic) - run after all controls are rendered
            strOut = "<script Language='JavaScript'> window.onload=initContent; function initContent() { "
            For intCurrTab = 1 To UBound(TabListAction)
                If intCurrTab <> TabSelected Then
                    strOut = strOut & "document.getElementById(""" & TabListAction(intCurrTab) & """).style.display='none';"
                Else
                    strOut = strOut & "document.getElementById(""" & TabListAction(intCurrTab) & """).style.display='block';"
                End If
                If ApplyContentStyle Then
                    strOut = strOut & "document.getElementById(""" & TabListAction(intCurrTab) & """).className='TabContent';"
                    strOut = strOut & "document.getElementById(""" & TabListAction(intCurrTab) & """).style.width='" & Width & "';"
                    strOut = strOut & "document.getElementById(""" & TabListAction(intCurrTab) & """).style.height='" & Height & "';"
                End If
            Next
            strOut = strOut & " }</script>" & vbLf
            Response.Write(strOut)
        ElseIf TabType = TabTypeFrames Then
  	        If Height = "*" or Width = "*" Then Response.Write("<script Language='JavaScript'> window.onresize=resizeTabControl; window.onload=resizeTabControl; </script>")
        End If

		'"Render" section
        Dim strImageBase
        Dim intRow
        If TabCount = 0 Then
            Response.Write("No tabs added to Tab Control!")
        End If
        Response.Write("<table bgcolor='" & BGColor & "' width='" & Width & "' id='TabControl' cellpadding=0 cellspacing=0 border=0><tr>" & vbLf)
        Response.Write("<tr><td width='1' background='" & ControlImagePath & "tab_nothing.gif'></td><td background='" & ControlImagePath & "tab_nothing.gif'>" & vbLf)
        Response.Write("<table bgcolor='" & BGColor & "' cellpadding=0 cellspacing=0 BORDER=0><tr>" & vbLf)
        'Home button
        If TabType = TabTypeFrames And TabHome Then
            Response.Write("<td background='" & ControlImagePath & "tab_nothing.gif'>&nbsp;<a href='javascript:tabHome();'><img src='" & ControlImagePath & "tab_home.gif' border='0'></a>&nbsp;&nbsp;&nbsp;</td>" & vbLf)
        End If

        For intCurrTab = 1 To UBound(TabListText)
            'Tab or or off?
            If intCurrTab = TabSelected Then
                strImageBase = ControlImagePath & "tab_on_"
            Else
                strImageBase = ControlImagePath & "tab_off_"
            End If
            'Start new row?
            For intRow = 1 To UBound(RowList)
                If RowList(intRow) = intCurrTab Then
                    Response.Write("</tr></table><table bgcolor='" & BGColor & "' cellpadding=0 cellspacing=0 border=0><tr>" & vbLf)
                End If
            Next
            'Start tab
            Response.Write("<td nowrap><img id='TabLeft" & intCurrTab & "' border='0' src='" & strImageBase & "left.gif'></td>" & vbLf)
            'Middle of Tab
            Response.Write("<td id=TabMid" & intCurrTab & " class='Tab' valign='bottom' height='" & TabHeight &"' ")
            If TabWidth <> "" Then Response.Write("width='" & TabWidth & "' ")
            Response.Write("style=""background-Image:url('" & strImageBase & "mid.gif');"" nowrap onmouseover='TabOver(this)' onmouseout='TabOver(this)' ")
            If TabType = TabTypeDynamic Then Response.Write("onclick=""changeTabs(this, '" & TabListAction(intCurrTab) & "');"">")
            If TabType = TabTypePostBack Then Response.Write("onclick=""location.href='" & TabListAction(intCurrTab) & "';"">")
            If TabType = TabTypeFrames Then Response.Write("onclick=""changeTabs(this, 'TabContent" & intCurrTab & "');"">")
            If TabListIcon(intCurrTab) <> "" Then
                'Insert icon and v-align text
                Response.Write("<img src='" & TabListIcon(intCurrTab) & "' border=0> ")
            End If
            Response.Write("<span style='position:relative; top:-3px;'>" & TabListText(intCurrTab) & "</span></td>" & vbLf)
            'End tab
            Response.Write("<td nowrap><img id='TabRight" & intCurrTab & "' border='0' src='" & strImageBase & "right.gif'></td>" & vbLf)
        Next

        'End spacer
        Response.Write("</tr></table>" & vbLf)
        Response.Write("</td><td background='" & ControlImagePath & "tab_nothing.gif' width='99%'></td></tr></table>" & vbLf)

        'Content Area
        If TabType = TabTypeFrames Then
            For intCurrTab = 1 To UBound(TabListAction)
                Response.Write("<iframe ")
				if Width <> "*" then 
					Response.Write("width='" & Width & "' ")
				else
					Response.Write("width='100%' ")
				end if
				if Height <> "*" then 
					Response.Write("height='" & Height & "' ")
				else
					Response.Write("height='95%' ")
				end if
                Response.Write("id='TabContent" & intCurrTab & "' name='TabContent" & intCurrTab & "' src='" & TabListAction(intCurrTab) & "' frameborder=0")
                If intCurrTab = TabSelected Then
                     Response.Write(" style='display:block;'")
                Else
                     Response.Write(" style='display:none;'")
                End If
                If ApplyContentStyle Then
                    Response.Write(" class='TabContent'")
                End If
                Response.Write(">No IFrame Support!</iframe>" & vbLf)
            Next
        End If
	End Sub
	
End Class
%>